#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <rsbac/types.h>
#include <rsbac/syscalls.h>
#include <rsbac/getname.h>
#include <rsbac/error.h>
#include <rsbac/helpers.h>

int main(int argc, char ** argv)
{
  int res = 0;
  rsbac_pid_t pid=0;
  rsbac_uid_t user;
  enum rsbac_target_t target;
  char * progname;
  struct passwd * user_info_p;
  boolean remove = FALSE;
  int maxnum = 20;
  rsbac_uid_t caplist[20];
  int i;
  
  progname = argv[0];
  switch(argc)
    {
      case 5:
        target = get_target_nr(argv[1]);
        if(   (target != T_PROCESS)
           && (target != T_FILE))
          {
            fprintf(stderr, "%s: Invalid Target %s!\n", progname, argv[1]);
            exit(1);
          }
        if(!strcmp(argv[2],"remove"))
          remove = TRUE;
        else
          if(strcmp(argv[2],"add"))
            {
              fprintf(stderr, "%s: Invalid command %s!\n\n", argv[0], argv[2]);
              exit(1);
            }
        if(target == T_PROCESS)
          pid=strtol(argv[3],0,10);
        if(   (!(user_info_p = getpwnam(argv[4])))
           && (   (!(user_info_p = getpwuid(strtol(argv[4],0,0))))
               || (!(user_info_p->pw_uid) && strcmp("0",argv[4])) )
          )
          {
            fprintf(stderr, "%s: Warning: Unknown user %s, trying number!\n\n", argv[0], argv[4]);
            user = strtol(argv[4],0,0);
            if(!user)
              exit(1);
          }
        else
          {
            user = user_info_p->pw_uid;
          }
        if(target == T_PROCESS)
          {
            if(remove)
              res = rsbac_auth_remove_p_cap(pid, user);
            else
              res = rsbac_auth_add_p_cap(pid, user);
          }
        else
          {
            if(remove)
              res = rsbac_auth_remove_f_cap(argv[3], user);
            else
              res = rsbac_auth_add_f_cap(argv[3], user);
          }
        if(res < 0)
          error_exit(res);
        break;

      case 4:
        target = get_target_nr(argv[1]);
        if(target != T_FILE)
          {
            fprintf(stderr, "%s: Invalid Target %s!\n", progname, argv[1]);
            exit(1);
          }
        if(strcmp(argv[2],"get"))
          {
            fprintf(stderr, "%s: Invalid command %s!\n\n", argv[0], argv[2]);
            exit(1);
          }
        res = rsbac_auth_get_f_caplist(argv[3], caplist, maxnum);
        if(res < 0)
          error_exit(res);
        for(i=0; i<res; i++)
          printf("%u ", caplist[i]);
        printf("\n");
        break;

      default:
        printf("%s (RSBAC %s)\n***\n", argv[0], VERSION);
        printf("Use: %s TYPE add/remove target user\n", progname);
        printf("Use: %s FILE get filename\n", progname);
        printf("     TYPE = PROCESS or FILE,\n");
        printf("     target = pid or filename\n");
    }
  exit(res);
}
